TheLittleSpoon/Controllers/ArticlesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using TheLittleSpoon.Models;
using TheLittleSpoon.Data;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.AspNetCore.Hosting;
using Microsoft.EntityFrameworkCore;
using Microsoft.AspNetCore.Authorization;

namespace TheLittleSpoon.Controllers
{
    public class ArticlesController : Controller
    {
        private readonly LittleSpoonDBContext _context;
        private readonly IHostingEnvironment _env;

        private readonly string _articlesTransitionDataPath;

        public ArticlesController(LittleSpoonDBContext context, IHostingEnvironment env)
        {
            _context = context;
            _env = env;

            // Set path to file that holds the article transitions for training the ML
            // note - make sure that the "Copy to Output Directory" property of the file is set to "Copy Always"
            _articlesTransitionDataPath = System.IO.Path.Combine(_env.WebRootPath, "ml", "articles-transition-data.txt");
        }

        [Authorize]
        // GET: Articles
        public async Task<IActionResult> Index()
        {
            return View(await _context.Articles.ToListAsync());
        }

        public IActionResult ArticleError()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        // GET: Articles/Details/?
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var article = await _context.Articles.Include(a => a.Category).FirstOrDefaultAsync(m => m.ArticleId == id);

            if (article == null)
            {
                return RedirectToAction("ArticleError");
            }

            return View(article);
        }

        // GET: Articles/Create
        [Authorize]
        public IActionResult Create()
        {
            ViewBag.Categories = new SelectList(_context.Categories, "CategoryId", "Name");
            return View();
        }

        // POST: Articles/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Create([Bind("Header,Summary,Content,HomeImageUrl,CategoryId,Location,IsShowMap")] Article articleModel)
        {
            if (ModelState.IsValid)
            {
                articleModel.DateCreated = DateTime.Now;
                _context.Add(articleModel);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(articleModel);
        }

        // GET: Articles/Edit/?
        [Authorize]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var article = await _context.Articles.FindAsync(id);
            if (article == null)
            {
                return RedirectToAction("ArticleError");
            }

            ViewBag.Categories = new SelectList(_context.Categories, "CategoryId", "Name");

            return View(article);
        }

        // POST: Articles/Edit/?
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Edit(int id, [Bind("ArticleId,Header,Summary,Content,HomeImageUrl,CategoryId,Location,IsShowMap")] Article article)
        {
            if (id != article.ArticleId)
            {
                return RedirectToAction("ArticleError");
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Articles.Attach(article);
                    _context.Entry(article).Property(x => x.Content).IsModified = true;
                    _context.Entry(article).Property(x => x.Header).IsModified = true;
                    _context.Entry(article).Property(x => x.Summary).IsModified = true;
                    _context.Entry(article).Property(x => x.HomeImageUrl).IsModified = true;
                    _context.Entry(article).Property(x => x.CategoryId).IsModified = true;
                    _context.Entry(article).Property(x => x.Location).IsModified = true;
                    _context.Entry(article).Property(x => x.IsShowMap).IsModified = true;

                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!ArticleExists(article.ArticleId))
                    {
                        return RedirectToAction("ArticleError");
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(article);
        }

        // GET: Articles/Delete/?
        [Authorize]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var article = await _context.Articles
                .FirstOrDefaultAsync(m => m.ArticleId == id);
            if (article == null)
            {
                return RedirectToAction("ArticleError");
            }

            return View(article);
        }

        // POST: Articles/Delete/?
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var article = await _context.Articles.FindAsync(id);
            _context.Articles.Remove(article);
            await _context.SaveChangesAsync();

            return RedirectToAction(nameof(Index));
        }

        private bool ArticleExists(int id)
        {
            return _context.Articles.Any(e => e.ArticleId == id);
        }

        public async Task<IActionResult> Search(int? category, string header, string summary, DateTime? date)
        {
            var result = _context.Articles.AsQueryable();

            if (category != null)
                result = result.Where(x => x.CategoryId == category);
            if (!String.IsNullOrWhiteSpace(header))
                result = result.Where(x => x.Header.Contains(header));
            if (!String.IsNullOrWhiteSpace(summary))
                result = result.Where(x => x.Summary.Contains(summary));
            if (date.HasValue)
                result = result.Where(x => x.DateCreated.Value.Date == date.Value.Date);

            return Json(result);
        }

        public async Task<IActionResult> Comments(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var comments = await _context.Comments.Where(c => c.ArticleId == id.Value).ToListAsync();

            if (comments == null)
            {
                return RedirectToAction("ArticleError");
            }

            return Json(comments);
        }

        // This function is calles onlt when you "transition" between articles.
        // When a user presses an article in the "related" section, we first save the transition
        // and only then really redirect him to his requested article page
        public async Task<IActionResult> MoveRelated(int? prevId, int? newId)
        {
            if (prevId == null || newId == null)
            {
                return RedirectToAction("ArticleError");
            }

            // Insert to training-set only if the article id's are differnet
            if (prevId.Value != newId.Value)
            {
                // Create a new line for the training data file in format "0.0,0.0" (we need a float num for the ML model)
                string line = ((float)prevId).ToString("0.0") + ',' + ((float)newId).ToString("0.0");

                // Add new line to training data file
                System.IO.File.AppendAllText(_articlesTransitionDataPath, line + Environment.NewLine);
            }

            // Now really redirect to the requested article
            return RedirectToAction(nameof(Details), new { id = newId });
        }

        // This function is called via javascript in the "Details" view of an article
        public async Task<IActionResult> GetRelatedArticles(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            const int NUM_OF_RELATED_ARTICLES = 3;
            List<Article> relatedArticles = new List<Article>();

            try
            {
                // Get the related article to the viewed article
                int mlRelatedArticle = MachineLearning.GetRelatedArticle(_articlesTransitionDataPath, id.Value);

                // Make sure we don't recommend the same article as the viewed article
                if (mlRelatedArticle != id.Value)
                {
                    var article = await _context.Articles.FirstAsync(c => c.ArticleId == mlRelatedArticle);

                    if (article != null)
                    {
                        relatedArticles.Add(article);

                        // Get the related article to the related article
                        int mlRelatedToRelatedArticle = MachineLearning.GetRelatedArticle(_articlesTransitionDataPath, mlRelatedArticle);

                        // Check that the recommended article isn't itself or the previous recommended article
                        if (mlRelatedToRelatedArticle != mlRelatedArticle && mlRelatedToRelatedArticle != id.Value)
                        {
                            article = await _context.Articles.FirstAsync(c => c.ArticleId == mlRelatedToRelatedArticle);

TheLittleSpoon/Controllers/BMIController.cs
using System;
using Microsoft.AspNetCore.Mvc;
using TheLittleSpoon.Data;

namespace TheLittleSpoon.Controllers
{
    public class BMIController : Controller
    {
        public IActionResult BMI(Models.BMIFormData data)
        {
            data.BMIReport = BMICalculator.GetBMIValue(data.UserWeight, data.UserHieght);
            data.BMIReport.BmiValue = Math.Round(data.BMIReport.BmiValue, 2);

            ViewBag.BmiResult = data.BMIReport.BmiValue;
            ViewBag.BmiDesc = data.BMIReport.BmiDesc;

            return View();
        }
    }
}

TheLittleSpoon/Controllers/CategoriesController.cs
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using TheLittleSpoon.Models;
using TheLittleSpoon.Data;
using Microsoft.AspNetCore.Authorization;
using Microsoft.EntityFrameworkCore;


namespace TheLittleSpoon.Controllers
{
    public class CategoriesController : Controller
    {
        private readonly LittleSpoonDBContext _context;

        public CategoriesController(LittleSpoonDBContext context)
        {
            _context = context;
        }

        // GET: Categories
        [Authorize]
        public async Task<IActionResult> Index()
        {
            return View(await _context.Categories.ToListAsync());
        }

        public IActionResult CategoriesError()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        // GET: Categories/Details/1
        public async Task<IActionResult> Details(int? id)
        {
            ViewData["Articles"] = await _context.Articles
                .Where(x => x.CategoryId == id).ToListAsync();

            if (id == null)
            {
                return RedirectToAction("CategoriesError");
            }

            var categoryModel = await _context.Categories
                .FirstOrDefaultAsync(m => m.CategoryId == id);
            if (categoryModel == null)
            {
                return RedirectToAction("CategoriesError");
            }

            return View(categoryModel);
        }

        [Authorize]
        // GET: Categories/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: Categories/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Create([Bind("CategoryId, Name, Description, Color")] Category categoryModel)
        {
            if (ModelState.IsValid)
            {
                _context.Add(categoryModel);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(categoryModel);
        }

        // GET: Categories/Edit/1
        [Authorize]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("CategoriesError");
            }

            var categoryModel = await _context.Categories.FindAsync(id);
            if (categoryModel == null)
            {
                return RedirectToAction("CategoriesError");
            }
            return View(categoryModel);
        }

        // POST: Categories/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Edit(int id, [Bind("CategoryId, Name, Description, Color")] Category categoryModel)
        {
            if (id != categoryModel.CategoryId)
            {
                return RedirectToAction("CategoriesError");
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(categoryModel);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!CategoryModelExists(categoryModel.CategoryId))
                    {
                        return RedirectToAction("CategoriesError");
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(categoryModel);
        }

        // GET: Categories/Delete/5
        [Authorize]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("CategoriesError");
            }

            var categoryModel = await _context.Categories
                .FirstOrDefaultAsync(m => m.CategoryId == id);
            if (categoryModel == null)
            {
                return RedirectToAction("CategoriesError");
            }

            return View(categoryModel);
        }

        // POST: Categories/Delete/1
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            // Remove articles of the selected category
            foreach (Article article in _context.Articles.Where(article => article.CategoryId == id))
            {
                _context.Articles.Remove(article);
            }

            var categoryModel = await _context.Categories.FindAsync(id);
            _context.Categories.Remove(categoryModel);

            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool CategoryModelExists(int id)
        {
            return _context.Categories.Any(e => e.CategoryId == id);
        }
    }
}

TheLittleSpoon/Controllers/SearchController.cs
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using TheLittleSpoon.Models;
using TheLittleSpoon.Data;

namespace TheLittleSpoon.Controllers
{
    public class SearchController : Controller
    {
        private readonly LittleSpoonDBContext _context;

        public SearchController(LittleSpoonDBContext context)
        {
            _context = context;
        }

        public async Task<IActionResult> Index()
        {
            ViewBag.Categories = _context.Categories.ToList<Category>();
            return View();
        }
    }
}

TheLittleSpoon/Views/Shared/BMI.cshtml
<!DOCTYPE html>
<html lang="en">

<body>
    <script type="text/javascript" src="/js/materialize.min.js"></script>
    @model TheLittleSpoon.Models.BMIFormData

<div class="bmi-calculator text-center align-items-center" style="justify-content:center;align-self:center;display:grid">
    <h1 class="display-2">BMI Calculator</h1>
    <br />
    <div class="row">
        <form id="bmi-form" class="form" asp-controller="BMI" asp-action="BMI" method="post" onsubmit="return check_fields()">
            <div class="row">
                <div class="col"><input id="weight-input" asp-for="UserWeight" type="number" style="width:500px" class="form-control" placeholder="Enter Weigth (kg)"></div>
                <div class="col"><input id="hiegth-input" asp-for="UserHieght" type="number" style="width:500px" class="form-control" placeholder="Enter Hiegth (cm)"></div>
            </div>
            <br />

                <button class="btn btn-success" type="submit" name="action">
                    Calculate
                </button>

        </form>
    </div>
    <br />
    <br />
    <br />
    <div class="row" style="justify-content:center;align-self:center;display:grid">
        @if (ViewBag.BmiResult != null && ViewBag.BmiDesc != null)
        {
            <div class="card" id="bmi-card">
                <div class="card-body">
                    <div class="card-content text-white">
                        <h5 class="card-title"><u>BMI Results</u></h5>
                        <h4 style="text-shadow: 3px 3px #000000"> Your BMI value is @ViewBag.BmiResult </h4>
                        <h4 style="text-shadow: 3px 3px #000000"> Your result is @ViewBag.BmiDesc </h4>
                    </div>
                </div>
            </div>
        }
    </div>
</div>
</body>
</html>

<script>
    function check_fields() {
        var w = document.forms["bmi-form"]["weight-input"];
        var h = document.forms["bmi-form"]["hieght-input"];
        if (w.value == "" || h.value == "") {
            alert("Please enter weight and hieght");
            return false;
        }
        return true;
    }
</script>

TheLittleSpoon/Views/Shared/_ArticleHorizontal.cshtml
@model TheLittleSpoon.Models.Article

<div class="card flex-md-row mb-4 shadow-sm h-md-250">
    <div class="card-body d-flex flex-column align-items-start" style="background-color: #f2eeee;">
        <partial name="_CategoryBadge" model="@Model.Category" />
        <h3 class="mb-0">
            <a class="text-dark" asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId">@Html.DisplayFor(model => model.Header)</a>
        </h3>
        <div class="mb-1 text-muted">@Html.DisplayFor(model => model.DateCreated)</div>
        <p class="card-text mb-auto">@Html.DisplayFor(model => model.Summary)</p>
        <a class="btn btn-sm btn-outline-secondary" asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId">Read more...</a>
    </div>
    <a asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId" class="bg-dark">
        <img class="card-img-right flex-auto d-none d-lg-block" style="width: 400px; height: 250px;" src="@Html.DisplayFor(model => model.HomeImageUrl)">
    </a>
</div>

TheLittleSpoon/Views/Shared/_ArticleVertical.cshtml
@*
    For more information on enabling MVC for empty projects, visit http://go.microsoft.com/fwlink/?LinkID=397860
*@

@model TheLittleSpoon.Models.Article

<div class="card" style="width: 18rem; background-color: #f2eeee">
    <a asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId">
        <img data-toggle="tooltip"
             data-html="true"
             data-placement="bottom"
             title="@Html.DisplayFor(model => model.Summary)"
             class="card-img-top"
             data-src="holder.js/100px180/"
             alt="100%x180"
             style="height: 180px; width: 100%; display: block;"
             src="@Html.DisplayFor(model => model.HomeImageUrl)"
             data-holder-rendered="true">
    </a>
    <div class="card-body">
        <h5 class="card-title">@Html.DisplayFor(model => model.Header)</h5>
        <!--<p class="card-text">@Html.DisplayFor(model => model.Summary)</p>-->
        <a class="btn btn-sm btn-outline-secondary" asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId">Read more...</a>
    </div>
</div>

TheLittleSpoon/Views/Shared/_CategoryBadge.cshtml
@model TheLittleSpoon.Models.Category

<a asp-controller="Categories" asp-action="Details" asp-route-id="@Model.CategoryId">
    <span class="badge badge-secondary" style="background-color: @Model.HexColor">@Html.DisplayFor(model => model.Name)</span>
</a>

TheLittleSpoon/Views/Shared/_HeaderPartial.cshtml
@using Microsoft.AspNetCore.Identity
@using TheLittleSpoon.Models

@inject SignInManager<ApplicationUser> SignInManager
@inject UserManager<ApplicationUser> UserManager

        <header class="blog-header border shadow-sm" style="margin-bottom:1+5px">
            <div class="container">
                <div class="d-flex justify-content-between">
                    <div class="p-2">
                        @if (SignInManager.IsSignedIn(User))
                {
                        <form asp-area="" asp-controller="Account" asp-action="Logout" method="post" id="logoutForm" class="btn-group btn-group-justified" role="group">
                            <button type="submit" class="btn btn-outline-secondary">Log out</button>
                            <a asp-controller="Categories" asp-action="Index" class="btn btn-outline-secondary">Categories</a>
                            <a asp-controller="Articles" asp-action="Index" class="btn btn-outline-secondary">Recipes</a>
                            <a asp-controller="Statisticss" asp-action="Index" class="btn btn-outline-secondary">Statistics</a>
                        </form>
                }
                else
                {
                        <a class="btn btn-sm btn-outline-secondary" asp-area="" asp-controller="Account" asp-action="Login">Log in</a>
                }
                    </div>
                    <div class="p-2 bd-highlight">

                        <a class="text-muted" href="@Url.Action("Index", "Search")" style="vertical-align: super;">
                            <svg xmlns="http://www.w3.org/2000/svg" style="vertical-align: sub;margin-top:5px" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="mx-3">
                                <circle cx="10.5" cy="10.5" r="7.5"></circle>
                                <line x1="21" y1="21" x2="15.7" y2="15.7"></line>
                            </svg>
                        </a>

                        @if (SignInManager.IsSignedIn(User))
                {
                        <span class="badge badge-success">ADMIN MODE</span>
                }
                else
                {
                      
                }
                    </div>
                </div>
            </div>
        </header>

TheLittleSpoon/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - TheLittleSpoon</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap-4.0.0/dist/css/bootstrap.min.css" />
        <link rel="stylesheet" href="~/lib/simplemde/dist/simplemde.min.css" />
        <link rel="stylesheet" href="~/fonts/Alef/Alef.css">
        <link rel="stylesheet" href="~/css/site.css" />
        <link rel="stylesheet" href="~/css/articles.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
</head>
<body style="padding-top:0px">
    <nav class="navbar navbar-expand-lg navbar-fixed-top navbar-dark bg-dark">
        <div class="container">
            <div class="navbar-header">
                <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand">TheLittleSpoon</a>
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li class="nav-item"><a class="nav-link" asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                    <li class="nav-item"><a class="nav-link" asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                    <li class="nav-item"><a class="nav-link" asp-area="" asp-controller="Home" asp-action="BMI">BMI Calculator</a></li>
                </ul>
            </div>
        </div>
    </nav>
    
    <partial name="_HeaderPartial" />
    <partial name="_CookieConsentPartial" />

    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>Send new recipes to littlespoon@gmail.com</p>
            <p>&copy; 2019 - TheLittleSpoon</p>
        </footer>
    </div>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/jquery-tmpl/jquery.tmpl.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/lib/showdown/dist/showdown.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
        <script src="~/js/markdown.js"></script>
        <script src="~/js/search.js"></script>
        <script src="~/js/comments.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-3.3.1.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-tsQFqpEReu7ZLhBV2VZlAu7zcOV+rXbYlF2cqB8txI/8aZajjp4Bqd+V6D5IgvKT">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-aJ21OjlMXNL5UyIl/XNwTMqvzeRMZH2w8c5cRVpzpU8Y5bApTppSuUkhZXN0VxHd">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("Scripts", required: false)
</body>
</html>